• HDU 1028 Ignatius and the Princess III (母函数或者dp,找规律,)


    Ignatius and the Princess III

    Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
    Total Submission(s): 15942    Accepted Submission(s): 11245


    Problem Description
    "Well, it seems the first problem is too easy. I will let you know how foolish you are later." feng5166 says.

    "The second problem is, given an positive integer N, we define an equation like this:
      N=a[1]+a[2]+a[3]+...+a[m];
      a[i]>0,1<=m<=N;
    My question is how many different equations you can find for a given N.
    For example, assume N is 4, we can find:
      4 = 4;
      4 = 3 + 1;
      4 = 2 + 2;
      4 = 2 + 1 + 1;
      4 = 1 + 1 + 1 + 1;
    so the result is 5 when N is 4. Note that "4 = 3 + 1" and "4 = 1 + 3" is the same in this problem. Now, you do it!"
     
    Input
    The input contains several test cases. Each test case contains a positive integer N(1<=N<=120) which is mentioned above. The input is terminated by the end of file.
     
    Output
    For each test case, you have to output a line contains an integer P which indicate the different equations you have found.
     
    Sample Input
    4 10 20
     
    Sample Output
    5 42 627
     
    Author
    Ignatius.L
     
    Recommend
    We have carefully selected several similar problems for you:  1085 1398 2152 1709 1059
     
    一开始自己想了一种解法,类似dp,但是应该不是dp,应该算找规律,速度没dp快,因为多了一层循环,虽然最里面一层循环很小,
    #include<queue>
    #include<math.h>
    #include<stdio.h>
    #include<string.h>
    #include<string>
    #include<iostream>
    #include<algorithm>
    using namespace std;
    #define N 130
    int n,d[N][N];//d[i][j]表示组成不超过j的数组成i有多少种方法
    
    int main()
    {
        for(int i=1;i<=120;i++)d[i][1]=1;
        d[0][0]=1;
        for(int i=2;i<=120;i++)
        {
            for(int j=2;j<=i;j++)
            {
                for(int k=j;k>=1;k--)
                {
                    d[i][j]+=d[i-k][min(i-k,k)];
                }
            }
        }
        while(~scanf("%d",&n))
        {
            cout<<d[n][n]<<endl;
        }
        return 0;
    }

    看了网上的正规dp解法,稍加改进

    #include<queue>
    #include<math.h>
    #include<stdio.h>
    #include<string.h>
    #include<string>
    #include<iostream>
    #include<algorithm>
    using namespace std;
    #define N 130
    int n,d[N][N];
    
    int main()
    {
        for(int i=1;i<=120;i++)d[i][1]=1;
        d[0][0]=1;
        for(int i=2;i<=120;i++)
        {
            for(int j=2;j<=i;j++)
            {
                d[i][j]=d[i][j-1]+d[i-j][min(j,i-j)];
            }
        }
        while(~scanf("%d",&n))
        {
            cout<<d[n][n]<<endl;
        }
        return 0;
    }

    还有一种母函数的做法

    以后再学习

  • 相关阅读:
    HDU 2112 HDU Today,最短路径算法,Dijkstra
    最小生成树,POJ和HDU几道题目的解题报告(基于自己写的模板)
    图基本算法 最小生成树 Prim算法(邻接表/邻接矩阵+优先队列STL)
    合并相同值得单元格(纵向)
    request.startAsync()不支持异步操作
    DIV强制不换行
    兼容各浏览器的css背景图片拉伸代码
    程序猿之八荣八耻
    使用JEECG过程中的问题汇总(持续更新)
    Firefox的缓存问题
  • 原文地址:https://www.cnblogs.com/wmxl/p/4781593.html
Copyright © 2020-2023  润新知